#include "jukebox.h"

#define HISTSIZE 1000

int histbuf[HISTSIZE];

int hist_wptr;
int hist_current;

init_history()
{
   int i;
   for(i=0;i<HISTSIZE;i++) histbuf[i] = -1;
   hist_wptr = 0;
   hist_current = 0;
}

int hist_backward()
{
   int n = hist_current-1;
   //printf("hist_backward() called, wptr=%d, current=%d\n",hist_wptr,hist_current);
   if(n<0) n = HISTSIZE-1;
   if(n==hist_wptr) return -1;
   if(histbuf[n]<0) return -1;
   hist_current = n;
   //printf("---hist_backward returns %d, wptr=%d\n",n,hist_wptr);
   return histbuf[n];
}

int hist_forward()
{
   int n;
   //printf("hist_forward() called, wptr=%d, current=%d\n",hist_wptr,hist_current);
   if(hist_wptr == hist_current) return -1;
   n = (hist_current+1) % HISTSIZE;
   if(histbuf[n]<0) return -1;
   hist_current = n;
   //printf("---hist_backward returns %d, wptr=%d\n",n,hist_wptr);
   return histbuf[n];
}

hist_new(int n)
{
   //printf("hist_new() called, wptr=%d, current=%d\n",hist_wptr,hist_current);
   if(histbuf[hist_current]==n) {
      //printf("---Same song again, history umodified\n");
      return;
   }
   while(hist_wptr != hist_current) {
      histbuf[hist_wptr] = -1;
      //printf("--- invalidated entry %d\n",hist_wptr);
      hist_wptr--;
      if(hist_wptr<0) hist_wptr=HISTSIZE-1;
   }
   hist_current = (hist_current+1) % HISTSIZE;   
   hist_wptr = hist_current;
   histbuf[hist_current] = n;
   //printf("---hist_new set both pointers to %d\n",hist_wptr);
}
