#include "jukebox.h"

char lcd_contents[80];

int lcd_is_off = 0;

FILE *serial_fp = 0;

init_serial()
{
   int i;
   system("stty -F /dev/ttyS0 9600 raw pass8 -echo clocal -crtscts");

   serial_fp = fopen("/dev/ttyS0","w");
   if(!serial_fp) {
      fprintf(stderr,"could not open tty\n");
      exit(999);
   }
}

init_lcd()
{
   int i;
   if(!serial_fp) init_serial();
   putc(0,serial_fp);
   putc(0,serial_fp);
   putc(0x38,serial_fp);
   putc(0,serial_fp);
   putc(0x0c,serial_fp);
   putc(0,serial_fp);
   putc(0x06,serial_fp);
   putc(0,serial_fp);
   putc(0x01,serial_fp);
   fflush(serial_fp);
   for(i=0;i<20;i++) putc(0xff,serial_fp);  // waste time to let it finish
   fflush(serial_fp);
   memset(lcd_contents,' ',80);
}

lcd_off()
{
   int i;
   putc(0x00,serial_fp);  // clear/home LCD
   putc(0x01,serial_fp);
   for(i=0;i<20;i++) putc(0xff,serial_fp);  // waste time to let it finish
   putc(0x00,serial_fp);
   putc(0x80,serial_fp);  // Turn the light off
   fflush(serial_fp);
   memset(lcd_contents,' ',80);
   //printf("LCD off.\n");
   lcd_is_off = 1;
}

update_lcd(char *buf)
{
   int i,lp=-1;

   //printf("LCD: ");
   //for(i=0;i<40;i++) putchar(buf[i]);
   //printf("\nLCD: ");
   //for(i=40;i<80;i++) putchar(buf[i]);
   //printf("\n");

   for(i=0;i<80;i++) {
      if(buf[i] != lcd_contents[i]) {
         if(lp<0 || (i-lp)>3) {
            putc(0,serial_fp);
            putc(0x80+((i>39)?i+24:i),serial_fp);
            //printf("pos %d\n",i);
         } else {
            while((++lp) < i) {
               putc(buf[lp],serial_fp);
               //printf("put %c\n",buf[lp]);
            }
         }
         putc(buf[i],serial_fp);
         //printf("put %c\n",buf[i]);
         lcd_contents[i] = buf[i];
         lp = i;
      }
   }
   fflush(serial_fp);
   lcd_is_off = 0;
}
