#include "jukebox.h"

static int mixfd = -1;

mixer_set(enum mix_channels which, int value)
{
   unsigned long v = value | (value<<8);
   int cmd;

   if(mixfd<0) {
      mixfd = open("/dev/mixer",0);
      if(mixfd<0) {
         perror("mixer open");
         exit(999);
      }
   } 

   switch(which) {
     case mix_mainvol:  cmd = SOUND_MIXER_WRITE_VOLUME; break;
     case mix_radio:    cmd = SOUND_MIXER_WRITE_LINE;   break;
#ifdef SYNTH_KLUDGE
     case mix_pcm:      cmd = SOUND_MIXER_WRITE_SYNTH;  break;
#else
     case mix_pcm:      cmd = SOUND_MIXER_WRITE_PCM;    break;
#endif
     default:
        fprintf(stderr,"Bad mixer channel\n");
        return;
   }

   if (ioctl(mixfd, cmd, &v)<0) {
      perror("mixer ioctl");
   }
}
